unit AntFuncts;

interface
uses
  Windows, SysUtils, Classes, Controls, strfconst;

  type

    TWordDesc = record
      FRow   : integer;
      FCol   : integer;
      FDelim : boolean;
      FOther : pointer;
    end;
    pWordDesc = ^TWordDesc;

    TWordDescList = array of TWordDesc;
    pWordDescList = ^TWordDescList;

  TBeforAddWordProc = function (const AWord:string;AStringList:TStringList;var AString:string;
  var AIsDelimiter:boolean;const ACol,ARow:integer;var AContFromCol,AContFromRow,AEndCol,AEndRow:integer;var ADelims:TDelims;var ABreak:boolean;var ANotes:pointer):boolean of object;
  TCompFunct = function (const A,B:OleVariant;out AFirstDifCharPos:integer;const ACaseInsensitive:Boolean;const AAnsiComp:Boolean):HResult;

  function GenEmptyStringsText(const iCount:cardinal):string;
  function IsStringInArray(const AString:string;const AStrArray:array of string;const ACaseInSensitive:boolean=true):integer;
  function IsIntegerInArray(const AInteger:integer;const AIntArray:array of integer):integer;
  function ColIndex(const AColName:OleVariant;var AMatrix:OleVariant):integer;

  function IsValidDate(ADateStr:string):boolean;
  function FindNearestSmalerDate(ADateArray:OleVariant; var ADate:OleVariant):Integer;
  procedure DelRowFrom1DimVarArray(var AArray:OleVariant;ARow:cardinal);
  procedure VarArrayCopy(const Search:OleVariant;var Dest:OleVariant;row:integer=1;col:integer=1;
                         sSRow:integer=-1;sSCol:integer=-1;sERow:integer=-1;sECol:integer=-1);
  procedure VarArrayMergeRow(var AVarArray:OleVariant);
  procedure VarArrayDelRow(var AVarArray:OleVariant;ARow:integer=-1);
  function VarArrayFindRow(var AKeyFields,AMatrix:OleVariant;const AFromIndex:integer=2):integer;

  function GetParamsVal(AMatrix : OleVariant; AName : string):OleVariant;
  procedure SetParamsVal(var AMatrix : OleVariant; AName : string; AVal : OleVariant);

  procedure RollStr(var AString:string;const ADirection:TDirection;const ACount:integer;const ABackWrite:boolean);
  function StringAlignToCenter(const AStr:string;const AFieldLen:integer):string;

  function PosFrom(var AString:String;ASubString:string;const AStartPos:integer; out AFoundLength:integer;const ADelims:TDelims;
    const ACaseInSensitive:boolean=true;const AEndPos:integer=-1;const AJokerChar:char='?';const AAsteriskChar:char='*'):integer;
  function PartialCompareStrings(AString,BString:string;out AFirstDifCharPos:integer;const ACaseInsensitive:Boolean;const AAnsiComp:Boolean):HResult;
  function BinSearch(AList:TStringList;var AStart,AEnd:integer;const AValue:OleVariant; ACompFunct:TCompFunct;const ADesc:boolean=False;
    const ACaseInSensitive:boolean=true; const AAnsi:boolean=true):HResult;overload;

  procedure AddWordToList(const AWord:string;var AString:string;var ACol,ARow,AContFromCol,AContFromRow,AEndCol,AEndRow:integer;const AIsDelimiter:boolean;const ACountList:boolean;
    AStringList:TStringList;ABeforAddWordProc:TBeforAddWordProc;var ADelims:TDelims;var ABreak:boolean);
  function GetWordFromPos(const AString:string;const ADelimiters:TDelims;var ACol:integer;
    const ADirection:TDirection=dirMiddle;const ADirectionIfDelimited:TDirection=dirMiddle):string;
  procedure GetWords(var AString:string;const ADelimiters:TDelims;const ACountOnly:boolean;AStringList:TStringList;
    ABeforAddWordProc:TBeforAddWordProc;ARow:integer=1;ACol:integer=1;const AEndCol:integer=-1;const AEndRow:integer=1);overload;
  procedure GetWords(AInStrings:TStrings;const ADelimiters:TDelims;ACountOnly:boolean;
    AStringList:TStringList;ABeforAddWordProc:TBeforAddWordProc;const ARow:integer=0;const ACol:integer=1;const AEndCol:integer=-1;const AEndRow:integer=-1);overload;


implementation
uses variants;

//******************************************************************************
// 2000, Papp Zoltan.
// Ures String generalasa sorzarassal
//
function GenEmptyStringsText(const iCount:cardinal):string;
Begin
  Result:=FillStr(iCount,#13#10);
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// A string a tombben van-e
//
function IsStringInArray(const AString:string; const AStrArray:array of string;const ACaseInSensitive:boolean=true):integer;
var cv : integer;
begin
  Result:=-1;
  for cv:=Low(AStrArray) to High(AStrArray) do
    if ACaseInSensitive and (AnsiLowerCase(AString)=AnsiLowerCase(AStrArray[cv]))then
    Begin
      Result:=cv;
      Exit;
    End
    else
    if AString=AStrArray[cv] then
    begin
      Result:=cv;
      Exit;
    end;
end;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Az integer a tombben van-e
//
function IsIntegerInArray(const AInteger:integer;const AIntArray:array of integer):integer;
var cv : integer;
Begin
  Result:=-1;
  for cv:=Low(AIntArray) to High(AIntArray) do
    if AInteger=AIntArray[cv] then
    Begin
      Result:=cv;
      Exit;
    End
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Oszlop sorszama a tombben
//
function ColIndex(const AColName:OleVariant;var AMatrix:OleVariant):integer;
var cv:integer;
Begin
  Result:=-1;
  if VarIsNull(AMatrix) or VarIsEmpty(AMatrix) or (VarArrayDimCount(AMatrix)<2) or (VarArrayHighBound(AMatrix,1)<1) then exit;
  for cv:=VarArrayLowBound(AMatrix,2) to VarArrayHighBound(AMatrix,2) do
    if AMatrix[1,cv]=AColName then
    Begin
      Result:=cv;
      Break;
    End;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000 jan.13, Papp Zoltan.
// A string atalakithato e datumma
//
function IsValidDate(ADateStr:string):boolean;
Begin
  try
    Result:=False;
    if (Length(ADateStr)>0) and (ADateStr[1]<>' ') then
    Begin
      StrToDate(ADateStr);
      Result:=True;
    End;
  Except
    On EConvertError do Result:=False;
  End
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000 febr.21, Papp Zoltan.
// Legkozelebbi kisebb datum keresese egy dimenzios tombbol
//
function FindNearestSmalerDate(ADateArray:OleVariant;var ADate:OleVariant):Integer;
var i:integer;
    Temp:TDate;
    TempArray:array of boolean;
    Low,High:integer;
Begin
  Low:=VarArrayLowBound(ADateArray,1);
  High:=VarArrayHighBound(ADateArray,1);
  Temp:=StrToDate(ADate);
  SetLength(TempArray,High);
  Result:=-1;
  ADate:=Null;
  for i:=Low to High do
    if StrToDate(ADateArray[i])<=Temp then
      TempArray[i-1]:=True
    else
      TempArray[i-1]:=False;
  for i:=Low to High do
    if TempArray[i-1] then
    Begin
      if Result=-1 then
      Begin
        Result:=i;
        ADate:=ADateArray[i];
      End
      else
      if StrToDate(ADateArray[i])>StrToDate(ADate) then
      Begin
        Result:=i;
        ADate:=ADateArray[i];
      End;
    End;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000.01.14, Papp Zoltan
// Sor torlese egy egy dimenzios varArray-bol
//
procedure DelRowFrom1DimVarArray(var AArray:OleVariant;ARow:cardinal);
var i:cardinal;
Begin
  for i:=ARow to VarArrayHighBound(AArray,1)-1 do
    AArray[i]:=AArray[i+1];
  VarArrayReDim(AArray,VarArrayHighBound(AArray,1)-1);
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000.01.14, Papp Zoltan
// varArray masolasa
//
procedure VarArrayCopy(const Search:OleVariant;var Dest:OleVariant;row:integer=1;col:integer=1;
  sSRow:integer=-1;sSCol:integer=-1;sERow:integer=-1;sECol:integer=-1);
var i,j,lvCol,lvRow:integer;
Begin
  if VarIsNull(Search) or VarIsEmpty(Search) or VarIsNull(Dest) or VarIsEmpty(Dest)
    or (VarArrayDimCount(Search)<>2) or (VarArrayDimCount(Dest)<>2) then exit;
  if sSRow=-1 then sSRow:=VarArrayLowBound(Search,1);
  if sERow=-1 then sERow:=VarArrayHighBound(Search,1);
  if sSCol=-1 then sSCol:=VarArrayLowBound(Search,2);
  if sECol=-1 then sECol:=VarArrayHighBound(Search,2);
  lvRow:=0;
  for i:=sSRow to sERow do
  Begin
    lvCol:=0;
    for j:=sSCol to sECol do
    Begin
      Dest[row+lvRow,col+lvCol]:=Search[i,j];
      inc(lvCol);
    End;
    inc(lvRow);
  End;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000.02.21, Papp Zoltan
// Sor hozzafuzese egy ket dimenzios tombbe
//
procedure VarArrayMergeRow(var AVarArray:OleVariant);
var TempArray:OleVariant;
    RowMin,RowMax,ColMin,ColMax:integer;
Begin
  if VarIsNull(AVarArray) or VarIsEmpty(AVarArray) or
     (VarArrayDimCount(AVarArray)<>2) then exit;
  RowMin:=VarArrayLowBound(AVarArray,1);
  ColMin:=VarArrayLowBound(AVarArray,2);
  RowMax:=VarArrayHighBound(AVarArray,1)+1;
  ColMax:=VarArrayHighBound(AVarArray,2);
  TempArray:=VarArrayCreate([RowMin,RowMax,ColMin,ColMax],varVariant);
  VarArrayCopy(AVarArray,TempArray,RowMin,ColMin);
  AVarArray:=TempArray;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000.02.21, Papp Zoltan
// Sor torlese egy ket dimenzios tombbol
//
procedure VarArrayDelRow(var AVarArray:OleVariant;ARow:integer=-1);
var TempArray:OleVariant;
    RowMin,RowMax,ColMin,ColMax,cv1,cv2,cv3:integer;
Begin
  if VarIsNull(AVarArray) or VarIsEmpty(AVarArray) or
     (VarArrayDimCount(AVarArray)<>2) then exit;
  RowMin:=VarArrayLowBound(AVarArray,1);
  ColMin:=VarArrayLowBound(AVarArray,2);
  RowMax:=VarArrayHighBound(AVarArray,1)-1;
  ColMax:=VarArrayHighBound(AVarArray,2);
  TempArray:=VarArrayCreate([RowMin,RowMax,ColMin,ColMax],varVariant);
  if ARow=-1 then
  Begin
    for cv1:=RowMin to RowMax do
      for cv2:=ColMin to ColMax do
        TempArray[cv1,cv2]:=AVarArray[cv1,cv2];
  End
  Else
  Begin
    cv3:=RowMin;
    for cv1:=RowMin to RowMax+1 do
    Begin
      if cv1=ARow then continue;
      for cv2:=ColMin to ColMax do
        TempArray[cv3,cv2]:=AVarArray[cv1,cv2];
      inc(cv3);
    End;
  End;
  AVarArray:=TempArray;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Sor keresese a tombben adott kulcsra
//
function VarArrayFindRow(var AKeyFields,AMatrix:OleVariant;const AFromIndex:integer=2):integer;
var cv1,cv2,lvLen,lvHigh,lvTemp:integer;
    lvFound:boolean;
    lvIndexes:array of integer;
Begin
  try
    Result:=-1;
    lvHigh:=VarArrayHighBound(AMatrix,1);

    if AFromIndex>lvHigh then
      Exit;

    lvFound:=True;
    for cv1:=1 to VarArrayHighBound(AKeyFields,2) do
    Begin
      lvTemp:=ColIndex(AKeyFields[1,cv1],AMatrix);
      if (lvTemp>-1) and
        not VarIsNull(AKeyFields[2,cv1]) and not VarIsEmpty(AKeyFields[2,cv1]) then
      Begin
        lvLen:=Length(lvIndexes);
        SetLength(lvIndexes,lvLen+1);
        lvIndexes[lvLen]:=lvTemp;
      End
      else
      Begin
        lvFound:=False;
        break;
      End;
    End;
    if lvFound then
    Begin
      lvFound:=False;
      for cv1:=AFromIndex to VarArrayHighBound(AMatrix,1) do
        if AMatrix[cv1,lvIndexes[0]]=AKeyFields[2,1] then
        Begin
          lvFound:=True;
          for cv2:=1 to lvLen do
            if AMatrix[cv1,lvIndexes[cv2]]<>AKeyFields[2,cv2+1] then
            Begin
              lvFound:=False;
              break;
            End;
          if lvFound then
          Begin
            Result:=cv1;
            Break;
          End;
        End;
    End;
  except
  end;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Parameter tombbol egy ertek lekerese
//
function GetParamsVal(AMatrix : OleVariant; AName : string):OleVariant;
var lvIndex: Integer;
begin
  lvIndex:=ColIndex(AName,AMatrix);
  if lvIndex>-1 then
    Result:= AMatrix[2, lvIndex];
end;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Parameter tombben egy ertek beallitasa
//
procedure SetParamsVal(var AMatrix : OleVariant; AName : string; AVal : OleVariant);
var lvIndex: Integer;
Begin
  lvIndex:=ColIndex(AName,AMatrix);
  if lvIndex>-1 then
    AMatrix[2, lvIndex]:=AVal;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Sz keresese egy masikban adott pozicitl (wildcardok s szhatrolk engedlyezve)
//
function PosFrom(var AString:String;ASubString:string;const AStartPos:integer; out AFoundLength:integer;const ADelims:TDelims;
  const ACaseInSensitive:boolean=true;const AEndPos:integer=-1;const AJokerChar:char='?';const AAsteriskChar:char='*'):integer;
var cv,cv1,cv2,lvStrLen,lvSubLen,lvSubStart,lvTempStart,lvEnd,lvFoundLength:integer;
    lvFound,lvExit:boolean;
    lvCharA,lvCharB:char;
Begin
  Result:=-1;
  AFoundLength:=0;
  lvFoundLength:=0;
  lvSubStart:=0;
  lvStrLen:=length(AString);
  lvSubLen:=length(ASubString);
  if AEndPos=-1 then
    lvEnd:=lvStrLen
  else
    lvEnd:=AEndPos;

  if (AStartPos<1) or (AStartPos>lvEnd) or (lvEnd>lvStrLen) or
     (AStartPos>lvStrLen) then
    exit;

  lvTempStart:=1;
  while (ASubString[lvTempStart]=AAsteriskChar) and (lvTempStart<lvSubLen) do
    inc(lvTempStart);
  if (lvTempStart=lvSubLen) and (ASubString[lvTempStart]=AAsteriskChar) then
    exit
  else
  if lvTempStart>1 then
  Begin
    ASubString:=Copy(ASubString,lvTempStart,lvSubLen-lvTempStart+1);
    lvSubLen:=length(ASubString);
  End;

  cv:=AStartPos;
  lvExit:=False;
  while (cv<=lvEnd) and (not lvExit) do
  Begin
    lvCharA:=AString[cv];
    lvCharB:=ASubString[1];
    if ACaseInSensitive then
    Begin
      lvCharA:=HuLowChar(lvCharA);
      lvCharB:=HuLowChar(lvCharB);
    End;
    if (lvCharA in ADelims) then
      break;
    if (lvCharA=lvCharB) or (lvCharB=AJokerChar) then
    Begin
      cv1:=1;
      lvFound:=true;
      Repeat
        if ((cv+cv1)>lvEnd) then
        Begin
          if (lvSubLen>cv1) and not(((cv1+1)=lvSubLen) and (ASubString[cv1+1]=AAsteriskChar)) then
            lvFound:=False;
          break;
        End;
        if (cv1+1)>lvSubLen then
          break;
        lvCharA:=AString[cv+cv1];
        lvCharB:=ASubString[cv1+1];
        if ACaseInSensitive then
        Begin
          lvCharA:=HuLowChar(lvCharA);
          lvCharB:=HuLowChar(lvCharB);
        End;
        if lvCharB=AAsteriskChar then
        Begin
          if (cv+cv1=lvStrLen) then
          Begin
            lvCharB:=ASubString[cv1+2];
            if ACaseInSensitive then
              lvCharB:=HuLowChar(lvCharB);
            if ((cv1+1)<lvSubLen) and
              not (  ( ((cv1+2)=lvSubLen) and (lvCharA=lvCharB) )
                   or ( ((cv1+3)=lvSubLen) and (ASubString[cv1+3]=AAsteriskChar) )  ) then
                lvFound:=False;
            inc(cv1);
            Break;
          End;
          if (cv1+1=lvSubLen) then
          Begin
            cv2:=cv+cv1;
            while (not(AString[cv2] in ADelims)) do
            Begin
              inc(cv2);
              if cv2>lvStrLen then
                break;
            End;
            lvFoundLength:=cv2-cv;
            lvSubStart:=cv;
            Break;
          End;

          lvSubStart:=PosFrom(AString,copy(ASubString,cv1+2,lvSubLen),cv+cv1,lvFoundLength,ADelims,ACaseInSensitive,-1,AJokerChar,AAsteriskChar);
          if lvSubStart>-1 then
            break
          else
          Begin
            lvFound:=False;
            lvExit:=True;
            break;
          End;
        End;
        if (lvCharA in ADelims) then
          break;
        if ((lvCharA<>lvCharB) and (lvCharB<>AJokerChar)) or (lvCharA in ADelims) then
        Begin
          lvFound:=False;
          break;
        End;
        inc(cv1);
      until ((cv1+1)>lvSubLen);
      if lvFound then
      Begin
        Result:=cv;
        if lvFoundLength=0 then
          AFoundLength:=cv1
        else
          AFoundLength:=lvSubStart-Result+lvFoundLength;
        break
      End;
      if ((cv+cv1)>lvEnd) or (AString[cv+cv1] in ADelims) then
        break;
    End;
    inc(cv);
  End;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Stringek hasonlitasa
//
function PartialCompareStrings(AString,BString:string;out AFirstDifCharPos:integer;const ACaseInsensitive:Boolean;const AAnsiComp:Boolean):HResult;
var cv:integer;
    lvALen,lvBLen:integer;
Begin
  lvALen:=Length(AString);
  lvBLen:=Length(BString);
  AFirstDifCharPos:=0;
  if (lvALen=0) or (lvBLen=0) then
  Begin
    Result:=CTotalEgale;
    exit;
  End;
  if ACaseInsensitive then
  Begin
    AString:=AnsiLowerCase(AString);
    BString:=AnsiLowerCase(BString);
  End;

  if lvALen>lvBLen then
    Result:=CPartialEgaleLongerThen
  else
  if lvALen<lvBLen then
    Result:=CPartialEgaleShorterThen
  else
    Result:=CTotalEgale;
  cv:=1;
  Repeat
    if AAnsiComp and (AString[cv] in CHuAlpha) and (BString[cv] in CHuAlpha) then
    Begin
      if (AString[cv] in CHuLowCaseAlphas) and (BString[cv] in CHuUpCaseAlphas) then
      Begin
        Result:=CSmallerThen;
        AFirstDifCharPos:=cv;
        Break;
      End
      else
      if (AString[cv] in CHuUpCaseAlphas) and (BString[cv] in CHuLowCaseAlphas) then
      Begin
        Result:=CGreaterThen;
        AFirstDifCharPos:=cv;
        Break;
      End
      else
      if AString[cv]<BString[cv] then
      Begin
        Result:=CSmallerThen;
        AFirstDifCharPos:=cv;
        Break;
      End
      else
      if AString[cv]>BString[cv] then
      Begin
        Result:=CGreaterThen;
        AFirstDifCharPos:=cv;
        Break;
      End;
    End
    else
    Begin
      if AString[cv]<BString[cv] then
      Begin
        Result:=CSmallerThen;
        AFirstDifCharPos:=cv;
        Break;
      End
      else
      if AString[cv]>BString[cv] then
      Begin
        Result:=CGreaterThen;
        AFirstDifCharPos:=cv;
        Break;
      End;
    End;
    inc(cv);
  Until (cv>lvBLen) or (cv>lvALen);
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Binaris kereses string listban, specialis lehetosegekkel
//
function BinSearch(AList:TStringList;var AStart,AEnd:integer;const AValue:OleVariant;
  ACompFunct:TCompFunct;const ADesc:boolean=False;const ACaseInSensitive:boolean=true;const AAnsi:boolean=true):HResult;
var lvTop,lvBottom,lvMiddle,lvFDifChar:integer;
    lvRes:HResult;
Begin
  lvTop:=AStart;
  lvBottom:=AEnd;
  Result:=CNotFound;
  while lvBottom>lvTop do
  Begin
    lvMiddle:=(lvTop+lvBottom) div 2;
    lvRes:=ACompFunct(AValue,AList.Strings[lvMiddle],lvFDifChar,ACaseInSensitive,AAnsi);
    case lvRes of
      CTotalEgale:
        Begin
          Result:=lvRes;
          AStart:=lvMiddle;
          Break;
        End;
      CGreaterThen,CPartialEgaleLongerThen:
        Begin
          if Result<>CPartialEgaleShorterThen then
          Begin
            Result:=lvRes;
            AStart:=lvMiddle;
          End;
          if ADesc then
            lvTop:=lvMiddle+1
          else
            lvBottom:=lvMiddle-1;
        End;
      CSmallerThen,CPartialEgaleShorterThen:
        Begin
          if lvRes=CPartialEgaleShorterThen then
          Begin
            Result:=lvRes;
            AStart:=lvMiddle;
          End
          else
          if Result<>CPartialEgaleShorterThen then
          Begin
            Result:=lvRes;
            AStart:=lvMiddle;
          End;
          if ADesc then
            lvBottom:=lvMiddle-1
          else
            lvTop:=lvMiddle+1;
        End;
    end;
  End;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// String forgatasa
//
procedure RollStr(var AString:string;const ADirection:TDirection;const ACount:integer;const ABackWrite:boolean);
var lvTemp:string;
Begin
  if ACount<Length(AString) then
    case ADirection of
      dirLeft:
        Begin
          lvTemp:=Copy(AString,ACount+1,Length(AString)-ACount+1);
          if ABackWrite then
            AString:=lvTemp+Copy(AString,1,ACount)
          else
            AString:=lvTemp+StringOfChar(' ',ACount);
        End;
      dirRight:
        Begin
          lvTemp:=Copy(AString,1,Length(AString)-ACount);
          if ABackWrite then
            AString:=Copy(AString,Length(AString)-ACount+1,ACount)+lvTemp
          else
            AString:=StringOfChar(' ',ACount)+lvTemp;
        End;
      dirMiddle:;
    end;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2001, Papp Zoltan.
// String kozepre igazitasa adott karakter-szelessegu mezoben
//
function StringAlignToCenter(const AStr:string;const AFieldLen:integer):string;
Begin
  Result:=Format('%-'+intToStr(AFieldLen)+'.'+intToStr(AFieldLen)+'s',[Format('%'+intToStr((AFieldLen div 2)+(length(AStr) div 2))+'.'+intToStr((AFieldLen div 2)+(length(AStr) div 2))+'s',[AStr])]);
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// String hozzaadasa a listahoz, specialis megjegyzesekkel
// a GetWords eljarasokhoz... Oszalyt kell majd inkabb irre.
procedure AddWordToList(const AWord:string;var AString:string;var ACol,ARow,AContFromCol,AContFromRow,AEndCol,AEndRow:integer;const AIsDelimiter:boolean;const ACountList:boolean;
  AStringList:TStringList;ABeforAddWordProc:TBeforAddWordProc;var ADelims:TDelims; var ABreak:boolean);
var lvWordDesc:pWordDesc;
    lvWordDescList:pWordDescList;
    lvWordIdx,lvLen:integer;
    lvNotes:pointer;
    lvIsDelimChar:boolean;
Begin
  lvIsDelimChar:=AIsDelimiter;
  if assigned(ABeforAddWordProc) and ABeforAddWordProc(AWord,AStringList,AString,lvIsDelimChar,ACol,ARow,AContFromCol,AContFromRow,AEndCol,AEndRow,ADelims,ABreak,lvNotes)
     and (not ABreak) and assigned(AStringList) then
    Begin
      if ACountList then
      Begin
        if not AStringList.Find(AWord,lvWordIdx) then
        Begin
          lvLen:=0;
          new(lvWordDescList);
          SetLength(lvWordDescList^,1);
          lvWordIdx:=AStringList.AddObject(AWord,TObject(lvWordDescList));
        End
        else
        Begin
          lvLen:=Length(pWordDescList(AStringList.Objects[lvWordIdx])^);
          SetLength(pWordDescList(AStringList.Objects[lvWordIdx])^,lvLen+1);
        End;
        with pWordDescList(AStringList.Objects[lvWordIdx])^[lvLen] do
        Begin
          FDelim:=lvIsDelimChar;
          FCol:=ACol;
          FRow:=ARow;
          FOther:=lvNotes;
        End;
      End
      else
      Begin
        new(lvWordDesc);
        lvWordDesc^.FRow:=ARow;
        lvWordDesc^.FCol:=ACol;
        lvWordDesc^.FDelim:=lvIsDelimChar;
        lvWordDesc^.FOther:=lvNotes;
        AStringList.AddObject(AWord,TObject(lvWordDesc));
      End;
    End;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Szo kivetele egy stringbol
//
function GetWordFromPos(const AString:string;const ADelimiters:TDelims;var ACol:integer;
  const ADirection:TDirection=dirMiddle;const ADirectionIfDelimited:TDirection=dirMiddle):string;
var cv,lvCol,lvLength,lvWordStart:integer;
Begin
  Result:='';
  lvLength:=length(AString);
  if ((ADirectionIfDelimited<>dirLeft) and (lvLength<ACol)) or (ACol<1) then
    exit
  else
  if ((ADirectionIfDelimited=dirLeft) and (lvLength<(ACol-1))) or (lvLength=0) then
    exit;

  if ADirection in [dirMiddle,dirLeft] then
  Begin
    if (ACol>lvLength) or ((AString[ACol] in ADelimiters) and (ADirectionIfDelimited=dirLeft) and (ACol>1)) then
      lvCol:=ACol-1
    else
      lvCol:=ACol;
    for cv:=lvCol downto 1 do
      if AString[cv] in ADelimiters then
        break;
    lvWordStart:=cv+1;
  End
  else
  Begin
    if (AString[ACol] in ADelimiters) and (ADirectionIfDelimited=dirRight) and (ACol<lvLength) then
      lvWordStart:=ACol+1
    else
      lvWordStart:=ACol;
  End;

  if ADirection in [dirMiddle,dirRight] then
  Begin
    if (ACol<lvLength) and (AString[ACol] in ADelimiters) and (ADirectionIfDelimited=dirRight) then
      lvCol:=ACol+1
    else
      lvCol:=ACol;
    for cv:=lvCol to lvLength do
      if AString[cv] in ADelimiters then
        break;
  End
  else
    cv:=ACol;

  Result:=Copy(AString,lvWordStart,cv-lvWordStart);
  ACol:=lvWordStart;
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Tokkenizalas egy stringbol
// Oszalyt kell majd inkabb irre.
procedure GetWords(var AString:string;const ADelimiters:TDelims;const ACountOnly:boolean;AStringList:TStringList;
  ABeforAddWordProc:TBeforAddWordProc;ARow:integer=1;ACol:integer=1;const AEndCol:integer=-1;const AEndRow:integer=1);
var lvCol,ContCol,ContRow,lvEndCol,lvEndRow,lvWordStart:integer;
    lvWord:string;
    lvBreak:boolean;
    lvDelims:TDelims;
Begin
  lvWordStart:=1;
  lvBreak:=false;
  lvDelims:=ADelimiters;
  lvCol:=ACol;
  ContRow:=ARow;
  ContCol:=lvCol;
  if AEndCol<1 then
    lvEndCol:=length(AString)
  else
    lvEndCol:=AEndCol;
  lvEndRow:=AEndRow;
  while (lvCol<=lvEndCol) and (lvCol>0) do
  Begin
    if AString[lvCol] in lvDelims then
    Begin
      if lvWord<>'' then
        AddWordToList(lvWord,AString,lvWordStart,ARow,ContCol,ContRow,lvEndCol,lvEndRow,false,ACountOnly,AStringList,ABeforAddWordProc,lvDelims,lvBreak);
      if lvBreak then
        break;

      lvWord:='';

      if ContRow<>ARow then
        Break;

      if ContCol<>lvCol then
      Begin
        lvCol:=ContCol;
        lvWordStart:=lvCol;
        Continue;
      End;

      AddWordToList(AString[lvCol],AString,lvCol,ARow,ContCol,ContRow,lvEndCol,lvEndRow,true,ACountOnly,AStringList,ABeforAddWordProc,lvDelims,lvBreak);
      if lvBreak or (ContRow<>ARow) then
        break;

      if ContCol<>lvCol then
      Begin
        lvCol:=ContCol;
        lvWordStart:=lvCol;
        continue;
      End
      else
        lvWordStart:=lvCol+1;
    End
    else
      lvWord:=lvWord+AString[lvCol];
    inc(lvCol);
    ContCol:=lvCol;
  End;
  if (not lvBreak) and (lvWord<>'') then
    AddWordToList(lvWord,AString,lvWordStart,ARow,ContCol,ContRow,lvEndCol,lvEndRow,false,ACountOnly,AStringList,ABeforAddWordProc,lvDelims,lvBreak);
End;
//------------------------------------------------------------------------------

//******************************************************************************
// 2000, Papp Zoltan.
// Tokkenizalas egy string-listabol
// Oszalyt kell majd inkabb irre.
procedure GetWords(AInStrings:TStrings;const ADelimiters:TDelims;ACountOnly:boolean;
  AStringList:TStringList;ABeforAddWordProc:TBeforAddWordProc;const ARow:integer=0;const ACol:integer=1;const AEndCol:integer=-1;const AEndRow:integer=-1);overload;
var lvCol,lvRow,ContCol,ContRow,lvEndCol,lvEndRow,lvWordStart:integer;
    lvWord:string;
    lvBreak:boolean;
    lvDelims:TDelims;
    lvString:string;
Begin
  lvWordStart:=1;
  lvBreak:=false;
  lvDelims:=ADelimiters;
  lvCol:=ACol;
  lvRow:=ARow;
  ContRow:=lvRow;
  ContCol:=lvCol;

  if (AEndRow<1) or (AEndRow>(AInStrings.Count-1)) then
    lvEndRow:=AInStrings.Count-1
  else
    lvEndRow:=AEndRow;

  while (lvRow<=(lvEndRow)) and (lvRow>-1) do
  Begin
    lvString:=AInStrings.Strings[lvRow];
    if (AEndCol<1) or (AEndCol>length(AInStrings.Strings[lvRow])) then
      lvEndCol:=length(AInStrings.Strings[lvRow])
    else
      lvEndCol:=AEndCol;
    while (lvCol<=lvEndCol) and (lvCol>0) do
    Begin
      if lvString[lvCol] in lvDelims then
      Begin
        if lvWord<>'' then
          AddWordToList(lvWord,lvString,lvWordStart,lvRow,ContCol,ContRow,lvEndCol,lvEndRow,false,ACountOnly,AStringList,ABeforAddWordProc,lvDelims,lvBreak);
        if lvBreak then
          break;

        lvWord:='';

        if ContRow<>lvRow then
          Break;

        if ContCol<>lvCol then
        Begin
          lvCol:=ContCol;
          lvWordStart:=lvCol;
          Continue;
        End;

        AddWordToList(lvString[lvCol],lvString,lvCol,lvRow,ContCol,ContRow,lvEndCol,lvEndRow,true,ACountOnly,AStringList,ABeforAddWordProc,lvDelims,lvBreak);
        if lvBreak then
          break;

        if ContRow<>lvRow then
          Break;

        if ContCol<>lvCol then
        Begin
          lvCol:=ContCol;
          lvWordStart:=lvCol;
          continue;
        End
        else
          lvWordStart:=lvCol+1;
      End
      else
        lvWord:=lvWord+lvString[lvCol];
      inc(lvCol);
      ContCol:=lvCol;
    End;
    
    if (not lvBreak) and (lvWord<>'') then
    Begin
      AddWordToList(lvWord,lvString,lvWordStart,lvRow,ContCol,ContRow,lvEndCol,lvEndRow,false,ACountOnly,AStringList,ABeforAddWordProc,lvDelims,lvBreak);
      lvWord:='';
    End;
    if lvBreak then
      Break;

    if ContRow=lvRow then
    Begin
      inc(lvRow);
      ContRow:=lvRow;
      if ContCol=lvCol then
      Begin
        lvCol:=1;
        ContCol:=lvCol;
        lvWordStart:=lvCol;
      End
      else
        lvCol:=ContCol; 
    End
    else
      lvRow:=ContRow;
  End;
End;
//------------------------------------------------------------------------------

end.
