unit UGetWord;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AntFuncts, strfconst;

type
  TForm1 = class(TForm)
    InputEDT: TEdit;
    SzamlalasCBX: TCheckBox;
    InputMMO: TMemo;
    OlvasasRGP: TRadioGroup;
    StartBtn: TButton;
    WordListMMO: TMemo;
    InfoCBX: TCheckBox;
    procedure StartBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    lvSList:TStringList;
    function CheckWordCount(const AWord:string;AStringList:TStringList;var AString:string;
      var AIsDelimiter:boolean;const ACol,ARow:integer;var AContFromCol,AContFromRow,AEndCol,AEndRow:integer;var ADelims:TDelims;var ABreak:boolean;var ANotes:pointer):boolean;
  public
  end;

const ClvDelimiters = CDocDelimiters+CBrackets;

var
  Form1: TForm1;
  BracketCount:integer;
  QuotaCount:integer;
implementation

{$R *.DFM}

function TForm1.CheckWordCount(const AWord:string;AStringList:TStringList;var AString:string;
  var AIsDelimiter:boolean;const ACol,ARow:integer;var AContFromCol,AContFromRow,AEndCol,AEndRow:integer;var ADelims:TDelims;var ABreak:boolean;var ANotes:pointer):boolean;
Begin
  Result:=True;
  ANotes:=nil;
  if AIsDelimiter and (AWord[1] in (CDocDelimiters+CBrackets)) then
  Begin
    case AWord[1] of
      '(':
          Begin
            inc(BracketCount);
          End;
      ')':
          Begin
            dec(BracketCount);
          End;
      chr(39):
          Begin
            if ADelims=[chr(39)] then
            Begin
              ADelims:=ClvDelimiters;
              dec(QuotaCount);
            End
            else
            Begin
              ADelims:=[chr(39)];
              inc(QuotaCount);
            End;
          End;
    end;
    if BracketCount<0 then
      ABreak:=True;
    Result:=False
  End
End;

procedure TForm1.StartBtnClick(Sender: TObject);
var cv,lvIndex:integer;
    lvString:string;
begin
  lvSList.Clear;
  WordListMMO.Clear;
  BracketCount:=0;
  QuotaCount:=0;
  if SzamlalasCBX.Checked then
    lvSList.Sorted:=True
  else
    lvSList.Sorted:=False;
  case OlvasasRGP.ItemIndex of
      0:
          Begin
            lvString:=InputEDT.Text;
            GetWords(lvString,ClvDelimiters,SzamlalasCBX.Checked,lvSList,CheckWordCount);
          End;
      1:
          GetWords(InputMMO.Lines,ClvDelimiters,SzamlalasCBX.Checked,lvSList,CheckWordCount);
  end;
  if (BracketCount<>0) or ((QuotaCount mod 2)>0) then
    ShowMessage('Bracket count error');
  for cv:=0 to lvSList.Count-1 do
  Begin
    if SzamlalasCBX.Checked then
    Begin
      lvIndex:=WordListMMO.Lines.Add(lvSList.Strings[cv]);
      if InfoCBX.Checked then
        WordListMMO.Lines[lvIndex]:=WordListMMO.Lines[lvIndex]+' ('+IntToStr(Length(pWordDescList(lvSList.Objects[cv])^))+')';
      Dispose(pWordDescList(lvSList.Objects[cv]));
    End
    else
    Begin
      lvIndex:=WordListMMO.Lines.Add(lvSList.Strings[cv]);
      if InfoCBX.Checked then
        WordListMMO.Lines[lvIndex]:=WordListMMO.Lines[lvIndex]+' ('+
        IntToStr(pWordDesc(lvSList.Objects[cv])^.FCol)+','+
        IntToStr(pWordDesc(lvSList.Objects[cv])^.FRow)+')';
      Dispose(pWordDesc(lvSList.Objects[cv]));
    End
  End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  lvSList:=TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  lvSList.Free;
end;

end.
