unit UStringParser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, UzStringParser;

type
  TForm1 = class(TForm)
    Button1: TButton;
    meSource: TMemo;
    ListBox1: TListBox;
    Button2: TButton;
    Edit2: TEdit;
    Label2: TLabel;
    meResult: TMemo;
    Label1: TLabel;
    Button3: TButton;
    OpenDialog: TOpenDialog;
    Label3: TLabel;
    chxMakeDifTypes: TCheckBox;
    rbtnLeftToRight: TRadioButton;
    rbtnRightToLeft: TRadioButton;
    cbxDelimTypes: TComboBox;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure chxMakeDifTypesClick(Sender: TObject);
    procedure cbxDelimTypesChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    sp:TzStringParser;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}
uses strfconst;
//    FS:TFileStream;
//  FS:=TFileStream.Create('',fmOpenRead);
//  FS.Free;

procedure TForm1.Button1Click(Sender: TObject);
begin
  meResult.Clear;
  if sp.MakeDif then
    sp.InputString:=meSource.text
  else
    sp.InputString:=StringReplace(meSource.text,#13#10,' ',[rfReplaceAll]);

  if rbtnLeftToRight.Checked then
  Begin
    sp.FCharPos:=0;
    while sp.GetNextToken(sp.LCharPos+1,dirRight) do
      if (sp.MakeDif and (sp.DelimIndex <> cbxDelimTypes.ItemIndex))
        or (not sp.MakeDif and not(sp.AsString[1] in sp.GetDelim(sp.DelimIndex))) then
          meResult.lines.Add(sp.asString)
  End
  else
  Begin
    sp.FCharPos:=Length(meSource.text)+1;
    while sp.GetNextToken(sp.FCharPos-1,dirLeft) do
      if (sp.MakeDif and (sp.DelimIndex <> cbxDelimTypes.ItemIndex))
        or (not sp.MakeDif and not(sp.AsString[1] in sp.GetDelim(sp.DelimIndex))) then
          meResult.lines.Add(sp.asString)
  End;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if OpenDialog.Execute then
    meSource.Lines.LoadFromFile(OpenDialog.FileName);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  sp:=TzStringParser.Create;
  sp.addDelim(CDocDelimiters);
  sp.addDelim(CBrackets);
  sp.addDelim(CHuAlpha);
  sp.addDelim(CNumbers);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  sp.Free;
end;

procedure TForm1.chxMakeDifTypesClick(Sender: TObject);
begin
  cbxDelimTypes.Enabled:=not chxMakeDifTypes.Checked;
  sp.MakeDif:=chxMakeDifTypes.Checked;
end;

procedure TForm1.cbxDelimTypesChange(Sender: TObject);
begin
  sp.DelimIndex:=cbxDelimTypes.ItemIndex;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  cbxDelimTypes.ItemIndex:=0;
end;

end.
